//+------------------------------------------------------------------+
//|                                                 MasterCandle.mq4 |
//|                                       Copyright  2010, Enforcer |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Enforcer"
#property link      "http://www.metaquotes.net"

extern int     BarsToCalc  = 350;
extern int     MinBarSize  = 150;
extern double  Lots        = 0.1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits == 3 || Digits == 5) MinBarSize *= 10;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   ObjectsDeleteAll();
   int    stoplevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   double range = 0, upper = 0, lower = 0, uplevel, downlevel;
   int    bar = 0;
    for (int i = 0; i < BarsToCalc; i++)
    {
      if(MathAbs(High[i] - Low[i]) > range) {range = MathAbs(High[i] - Low[i]); bar=i;}
    }
    
    uplevel    = NormalizeDouble(High[bar] - (range/3), Digits);
    downlevel  = NormalizeDouble(Low[bar]  + (range/3), Digits);
    if(range/Point >= MinBarSize)
    {
      if(Bid > uplevel   + (stoplevel*Point) && OrdersTotal() == 0) OrderSend(Symbol() ,OP_SELLSTOP,Lots,   uplevel, 0, NormalizeDouble(uplevel   + (range/3), Digits), downlevel, NULL, NULL, 0, Red);
      if(Ask < downlevel - (stoplevel*Point) && OrdersTotal() == 0) OrderSend(Symbol(), OP_BUYSTOP, Lots, downlevel, 0, NormalizeDouble(downlevel - (range/3), Digits), uplevel,   NULL, NULL, 0, Red);
    }
    
     for (int j = 0; j < OrdersTotal(); j++)
     {
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol() == Symbol())
         {
            if(OrderType() == OP_BUYSTOP  && OrderOpenPrice() != downlevel) {OrderDelete(OrderTicket()); return;}
            if(OrderType() == OP_SELLSTOP && OrderOpenPrice() != uplevel)   {OrderDelete(OrderTicket()); return;}
         }
     }

    Comment("\nMinBarSize=",MinBarSize,"\nrange=",range/Point,"\nbar=",bar,"\nuplevel=",uplevel);

      // if(ObjectFind("bar")==-1)
      {
         ObjectCreate("bar", OBJ_TREND, 0, Time[bar], High[bar], Time[bar], Low[bar]);
         ObjectSet   ("bar", OBJPROP_RAY, 0);
      }
      //if(ObjectFind("hi")==-1)
      {
         ObjectCreate("hi",  OBJ_TREND, 0, Time[bar], High[bar], Time[0], High[bar]);
         ObjectCreate("low", OBJ_TREND, 0, Time[bar], Low[bar],  Time[0], Low[bar]);
      }
      //if(ObjectFind("uplevel")==-1)
      {
         ObjectCreate("uplevel", OBJ_TREND, 0, Time[bar], uplevel ,Time[0], uplevel);
         ObjectSet   ("uplevel", OBJPROP_COLOR, Orange);
         ObjectSet   ("uplevel", OBJPROP_STYLE, STYLE_DASH);
      }
      //if(ObjectFind("downlevel")==-1)
      {
         ObjectCreate("downlevel", OBJ_TREND, 0, Time[bar], downlevel, Time[0], downlevel);
         ObjectSet   ("downlevel", OBJPROP_COLOR, Orange);
         ObjectSet   ("downlevel", OBJPROP_STYLE, STYLE_DASH);
      }

//----
   return(0);
  }
//+------------------------------------------------------------------+